/*
* HCS_Apollo.ino
*
* Created: 7/9/2015 9:43:20 PM
* Author: Tom Frederick
*
* -Add in reset upon timeout of connection with PS3
*/

#include <SPI.h>
#include <Servo.h>
#include "PS3BT.h"
#include <Servo.h>
USB Usb;
BTD Btd(&Usb); // You have to create the Bluetooth Dongle instance like so
/* You can create the instance of the class in two ways */
//PS3BT PS3(&Btd); // This will just create the instance
PS3BT PS3(&Btd, 0x00, 0x1F, 0x81, 0x00, 0x08, 0x30);

//                        1   2   3   4   5   6   7   8   9   10  11  12
Servo MOTOR[12];
int motorPin[12] =       {33, 32, 31, 30, 29, 28, 27, 26, 25, 24, 23, 22};
int Digital_SENSOR[10] = {38, 41, 40, 37, 36, 35, 34, 39, 42, 43};
//						            11   12   13   14   15   16   17   18   19   20
int Analog_SENSOR[10] =  {A13, A12, A11, A10, A9,  A8,  A7,  A6,  A5,  A4};

int dir[8] = {1, 1, 1, 1, 1, 1, 1, 1};
float spd[12] = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
int tempPos;
int pos[12] = {90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90};

int stopPoint = 90;

boolean bFirstLinkLoop = true, bBatteryUpdate = true;
boolean Pass = true;
boolean firstDisconnect = true;
int lowEnd = 0;
int highEnd = 180;

long connectTime = 0;
long disconnectTime = 0;
byte battery = 0, last_check = 0;

// This is the millisecond count before the Heartbeat stops
int messageTimeout = 250;
int GREEN_led = 49;
int RED_led = 5;
int BLUE_led = 3;

unsigned long enterTime = 0;
boolean autoMode = true;
boolean firstflag = true;

void setup()
{
  Serial.begin(57600);
  pinMode(GREEN_led, OUTPUT);
  digitalWrite(GREEN_led, HIGH);
  pinMode(RED_led, OUTPUT);
  digitalWrite(RED_led, HIGH);
  pinMode(BLUE_led, OUTPUT);
  digitalWrite(BLUE_led, HIGH);
  digitalWrite(GREEN_led, LOW);   // turn the LED on (HIGH is the voltage level)
  delay(300);               // wait for a second
  digitalWrite(GREEN_led, HIGH);    // turn the LED off by making the voltage LOW
  if (Usb.Init() == -1)
  {
    while (1); //halt
  }
  digitalWrite(BLUE_led, LOW);   // turn the LED on (HIGH is the voltage level)
  delay(300);               // wait for a second
  digitalWrite(BLUE_led, HIGH);    // turn the LED off by making the voltage LOW
  // Measure the Motor Battery Voltage
  Serial.print("Motor\t");
  Serial.println(analogRead(A14));
  if (analogRead(A14) < 600) { // Less than 7V
    digitalWrite(RED_led, LOW);   // turn the LED on (HIGH is the voltage level)
    delay(500);               // wait for a second
    digitalWrite(RED_led, HIGH);    // turn the LED off by making the voltage LOW
  }
  else if (analogRead(A14) < 700) { // Less than 7V
    digitalWrite(GREEN_led, LOW);
    digitalWrite(RED_led, LOW);
    delay(500);               // wait for a second
    digitalWrite(GREEN_led, HIGH);
    digitalWrite(RED_led, HIGH);
  }
  else{
    digitalWrite(GREEN_led, LOW);
    delay(500);             
    digitalWrite(GREEN_led, HIGH);
  }
  digitalWrite(GREEN_led, HIGH);    // turn the LED off by making the voltage LOW
  digitalWrite(RED_led, HIGH);    // turn the LED off by making the voltage LOW
  digitalWrite(BLUE_led, HIGH);    // turn the LED off by making the voltage LOW
  delay(500);
  // Measure the Micro Battery Voltage
  Serial.print("Micro\t");
  Serial.println(analogRead(A15));
  if (analogRead(A15) < 600) { // Less than 7V
    digitalWrite(RED_led, LOW);   // turn the LED on (HIGH is the voltage level)
    delay(500);               // wait for a second
    digitalWrite(RED_led, HIGH);    // turn the LED off by making the voltage LOW
  }
  else if (analogRead(A15) < 700) { // Less than 7V
    digitalWrite(GREEN_led, LOW);
    digitalWrite(RED_led, LOW);
    delay(500);               // wait for a second
    digitalWrite(GREEN_led, HIGH);
    digitalWrite(RED_led, HIGH);
  }
  else{
    digitalWrite(GREEN_led, LOW);
    delay(500);             
    digitalWrite(GREEN_led, HIGH);
  }

  for (int k = 0; k < 10; k++) {
    pinMode(Digital_SENSOR[k], INPUT_PULLUP);
  }
  for (int h = 0; h < 10; h++) {
    if (analogRead(Analog_SENSOR[h]) > 50) {
      spd[h] = 1.0;
    }
    else {
      spd[h] = 0.7;
    }
  }

  for (int i = 0; i < 12; i++) {

    MOTOR[i].attach(motorPin[i], 1000, 2000);

    if (i < 10) {
      if (digitalRead(Digital_SENSOR[i])) {
        dir[i] = 0;
      }
      else {
        dir[i] = 1;
      }
    }
    delay(50);
  }
}

void(* resetFunc)(void) = 0;

void loop()
{
  // This records the time of the first iteration
  if (firstflag)
  {
    enterTime = millis();
    //Serial.print("First Loop : ");
    //Serial.println(millis());
    firstflag = false;
  }

  // Read the USB port
  Usb.Task();

  // Run a Timer / Sensor Driven autonomous program
  // This structure should be used instead of delay() functions so that USB.task is repeatedly called

  // This will run autonomous for 10 seconds or until autoMode is set to false by pressing the Triangle and Cross at the same time.
  /*if(millis() - enterTime < 10000 && autoMode)
  {
    // Drive forward for 1 second
    if (millis() - enterTime < 1000)
    {
     S1.write(135);
     S2.write(135);
    }
    // Turn in place for 1000 milliseconds
    else if (millis() - enterTime < 2000)
    {
     S1.write(90);
     S2.write(45);
    }
    // Stop
    else
    {
      S1.write(90);
      S2.write(90);
    }

    // If the controller is connected and the Triangle and Cross button are pressed, jump out of the autonomous
    if(PS3.PS3Connected && PS3.getButtonPress(TRIANGLE) && PS3.getButtonPress(CROSS))
    {
     autoMode = false;
    }

    /* Example of triggering autonomous code from sensor input
    else if (potentiometerReading < fullyExtended)
    {
      //Raise the arm motors
    }
    *

  }
  else */
  if (PS3.PS3Connected)
  {

    //
    // If the last message was received more than messageTimeout, the remote control is properly disconnected.
    // When properly disconnected, the remote can more quickly reconnect
    //
    firstDisconnect = true;
    if (millis() - PS3.getLastMessageTime() > messageTimeout && !Pass)
    {
      disconnectAll();
      //Serial.println("Resetting");
      //delay(125);
      resetFunc();
    }
    //
    // Normal operating code goes in the 'else' statement below
    //
    else
    {
      Pass = false;

      digitalWrite(GREEN_led, LOW);
      // Upon linking, vibrate the controller
      if (bFirstLinkLoop) {
        connectTime = millis();        // Note the connection time
        bFirstLinkLoop = false;
        PS3.setRumbleOn(RumbleHigh);   // Set the rumble high
        delay(250);
        PS3.setRumbleOff();            // Turn off rumble
        delay(100);
        PS3.setRumbleOn(RumbleLow);    // Set the rumble low
        delay(250);
        PS3.setRumbleOff();            // Turn off rumble
      }

      //
      // Every 60 seconds update the battery indicator lights along the top
      //
      if (bBatteryUpdate == true)
      {
        if (PS3.getStatus(Dying))    {
          battery = 1;
        }
        else if (PS3.getStatus(Low)) {
          battery = 2;
        }
        else if (PS3.getStatus(High)) {
          battery = 3;
        }
        else if (PS3.getStatus(Full)) {
          battery = 4;
        }
        PS3.setLedOn(LED1);
        if (battery == 2 || battery == 3 || battery == 4) {
          PS3.setLedOn(LED2);
        }
        if (battery == 3 || battery == 4) {
          PS3.setLedOn(LED3);
        }
        if (battery == 4) {
          PS3.setLedOn(LED4);
        }
        bBatteryUpdate = false;
      }

      if (millis() / 60000 != last_check)
      {
        bBatteryUpdate = true;
        last_check = millis() / 60000;
      }

      // Map the remote control motions to the motor ports

      // Motor 1 - Right Joystick Up/Down
      if (dir[0] == 0) {
        pos[0] = map(PS3.getAnalogHat(RightHatY), 0, 255, lowEnd, highEnd);
      }
      else {
        pos[0] = map(PS3.getAnalogHat(RightHatY), 0, 255, highEnd, lowEnd);
      }

      // Motor 2 - Left Joystick Up/Down
      if (dir[1] == 0) {
        pos[1] = map(PS3.getAnalogHat(LeftHatY), 0, 255, highEnd, lowEnd);
      }
      else {
        pos[1] = map(PS3.getAnalogHat(LeftHatY), 0, 255, lowEnd, highEnd);
      }

      // Motor 3 - TRIANGLE/CROSS
      pos[2] = stopPoint;
      if (PS3.getButtonPress(TRIANGLE))
      {
        if (dir[2] == 0) {
          pos[2] = lowEnd;
        }
        else {
          pos[2] = highEnd;
        }
      }
      if (PS3.getButtonPress(CROSS))
      {
        if (dir[2] == 0) {
          pos[2] = highEnd;
        }
        else {
          pos[2] = lowEnd;
        }
      }

      // Motor 4 - DPAD Up/Down
      pos[3] = stopPoint;
      if (PS3.getButtonPress(UP))
      {
        if (dir[3] == 0) {
          pos[3] = lowEnd;
        }
        else {
          pos[3] = highEnd;
        }
      }
      if (PS3.getButtonPress(DOWN))
      {
        if (dir[3] == 0) {
          pos[3] = highEnd;
        }
        else {
          pos[3] = lowEnd;
        }
      }

      // Motor 5 - Left Triggers L1/L2
      pos[4] = stopPoint;
      if (dir[4] == 0) {
        pos[4] = map(PS3.getAnalogButton(L2), 0, 255, stopPoint, highEnd);
      }
      else {
        pos[4] = map(PS3.getAnalogButton(L2), 0, 255, stopPoint, lowEnd);
      }

      if (PS3.getButtonPress(L1))
      {
        if (dir[4] == 0) {
          pos[4] = lowEnd;
        }
        else {
          pos[4] = highEnd;
        }
      }

      // Motor 6 - Right Triggers R1/R2
      pos[5] = stopPoint;
      if (dir[5] == 0) {
        pos[5] = map(PS3.getAnalogButton(R2), 0, 255, stopPoint, highEnd);
      }
      else {
        pos[5] = map(PS3.getAnalogButton(R2), 0, 255, stopPoint, lowEnd);
      }

      if (PS3.getButtonPress(R1))
      {
        if (dir[5] == 0) {
          pos[5] = lowEnd;
        }
        else {
          pos[5] = highEnd;
        }
      }

      // Motor 7 - CIRCLE/SQUARE
      pos[6] = stopPoint;
      if (PS3.getButtonPress(CIRCLE)) {
        pos[6] = lowEnd;
      }
      if (PS3.getButtonPress(SQUARE)) {
        pos[6] = highEnd;
      }

      // Motor 8 - DPAD Left/Right
      pos[7] = stopPoint;
      if (PS3.getButtonPress(LEFT)) {
        pos[7] = lowEnd;
      }
      if (PS3.getButtonPress(RIGHT)) {
        pos[7] = highEnd;
      }

      // Set the deadbands on the joysticks
      int deadBand = 15;
      if (pos[0] < stopPoint + deadBand && pos[0] > stopPoint - deadBand) {
        pos[0] = stopPoint;
      }
      if (pos[1] < stopPoint + deadBand && pos[1] > stopPoint - deadBand) {
        pos[1] = stopPoint;
      }
      if (pos[4] < stopPoint + deadBand && pos[4] > stopPoint - deadBand) {
        pos[4] = stopPoint;
      }
      if (pos[5] < stopPoint + deadBand && pos[5] > stopPoint - deadBand) {
        pos[5] = stopPoint;
      }

      pos[8] = pos[0];
      pos[9] = pos[1];
      pos[10] = pos[2];
      pos[11] = pos[3];

      // Write the motor positions
      for (int i = 0; i < 12; i++) {
        tempPos = (int)(90 + (pos[i] - 90) * spd[i]);

        MOTOR[i].write(tempPos);
        if (pos[i] != 90) {
          Serial.print(i);
          Serial.print("\t");
          Serial.print(tempPos);
          Serial.print("\t");
          Serial.print(spd[i]);
          Serial.print("\t");
          Serial.println(pos[i]);
        }
      }

      // If it is requested, disconnect
      if (PS3.getButtonClick(PS))
      {
        disconnectAll();
      }
    }
  }
  else { // PS3 is disconnected
    if (firstDisconnect) {
      disconnectAll();
      firstDisconnect = false;
    }
    if (connectTime != 0 && millis() - disconnectTime > 10000) {
      resetFunc();
    }
  }
}

int setSpd(int pos, float spd) {
  if (pos > 90) {
    pos = 90 + (pos - 90) * spd;
  }
  else {
    pos = 90 + (pos - 90) * spd;
  }
  return pos;
}

//
// This function serves to reset necessary flags, turn off all motors, and properly disconnect the controller.
//
void disconnectAll() {

  // Control the Link LED
  digitalWrite(GREEN_led, HIGH);

  // Reset the flags that are used
  bFirstLinkLoop = true;
  bBatteryUpdate = true;

  // Stop all motors from turning
  for (int i = 0; i < 12; i++) {
    MOTOR[i].write(stopPoint);
  }

  // Disconnect correctly
  if (PS3.PS3Connected)
  {
    PS3.disconnect();
  }

  disconnectTime = millis();
  // This resets the heartbeat message
  Pass = true;
}
